% append(L1, L2, L3): Az L3 lista az L1 s L2 listk elemeinek 
% egyms utn fzsvel ll el (jelljk: L3 = L1 + L2).
append([], L, L).
append([X|L1], L2, [X|L3]) :-
        append(L1, L2, L3).

% L123 folytonos rszlistja L2 (L123 =  _ + L2 + _).
% L123 adott, L2 ismeretlen.
csublist(L2, L123) :-
        append(_L1, L23, L123), 
        append(L2, _L3, L23).

% Adott L123-nak folytonos rsze egy adott L2.
check_csublist(L2, L123) :-
        append(L2, _L3, L23), 
        append(_L1, L23, L123).

% mul_list(N, E, L0, L): L-L0 az E lista N-szeri egyms utn fzsvel ll el.
mul_list(0, _E, L, L).
mul_list(N, E, L0, L) :-
	N > 0, N1 is N-1,
	append(E, L1, L),
	mul_list(N1, E, L0, L1).

% A csublist/2 futsi ideje CsublistTime, a check_csublist/2- CheckCsublistTime.
test(CsublistTime, CheckCsublistTime)  :-
	mul_list(100000, [0,1,2,3,4], [10], L123),
	L2 = [0,1,2,3,4,10],
	statistics(runtime, _),
	csublist(L2, L123),
	statistics(runtime, [_,CsublistTime]),
	check_csublist(L2, L123),
	statistics(runtime, [_,CheckCsublistTime]).

% Ismtelten futtatja test/2-t.
test :-
	repeat, test(CsT, CCsT), write(CsT-CCsT), nl, fail.
