:- use_module(library(lists)).

% Kif a ngy alapmvelettel az L listban megadott szmokbl
% felptett kifejezs, amelynek rtke Ertek.
fa_erteke(L, Ertek, Kif) :-
	permutation(L, PL),
	fa_levelei(Fa, PL),
	fa_kif(Fa, Kif),
	Kif =:= Ertek.

% fa_levelei(?Fa, +L): Fa leveleinek listja L. 
fa_levelei(leaf(X), [X]).
fa_levelei(node(Left,Right), L) :-
	append(L1, L2, L),
	L1 = [_|_],
	L2 = [_|_],
	fa_levelei(Left, L1),
	fa_levelei(Right, L2).

% fa_kif(Fa, Kif): Kif a Fa faval azonos alak, azonos szmokbl ll
% aritmetikai kifejezs, amelyben a ngy alapmvelet fordulhat el.
fa_kif(leaf(V), V).
fa_kif(node(L,R), Exp) :-
	fa_kif(L, E1),
	fa_kif(R, E2),
	alap4(E1, E2, Exp).

% alap4(X, Y, Kif): Kif az X s Y kifejezsekbl a ngy alapmvelet egyikvel ll el.
alap4(X, Y, X+Y).
alap4(X, Y, X-Y).
alap4(X, Y, X*Y).
alap4(X, Y, X/Y).


% between(M, N, I): M =< I =< N, I egsz.
between(M, _, M).
between(M, N, I) :-
        M < N, 
        M1 is M+1,
        between(M1, N, I).
